﻿
using System;
using System.Collections.Generic;
using System.Drawing;
using Wisej.Web;

namespace Wisej.RealTimeClock
{
	public partial class Page1 : Page
	{
		private static int timerUserCount = 0;
		private static System.Timers.Timer timer;

		public Page1()
		{
			InitializeComponent();

			Application.ApplicationExit += (s, e) =>
			{

				timerUserCount--;
				timer.Elapsed -= Timer_Elapsed;

				if (timerUserCount == 0)
				{
					timer.Dispose();
					timer = null;
				}
			};
		}

		private void Page1_Load(object sender, EventArgs e)
		{
			timerUserCount++;

			lock (typeof(Program))
			{
				if (timer == null)
				{
					timer = new System.Timers.Timer(1000);
					timer.Enabled = true;
				}
			}

			timer.Elapsed += Timer_Elapsed;

			this.label3.Text += (-Application.Browser.TimezoneOffset/60) + "h";
		}

		private void Timer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
		{
			this.label1.Text = DateTime.Now.ToClientTime().ToLongTimeString();

			Application.Update(this);
		}

		private void label1_Rotate(object sender, RotateEventArgs e)
		{
			this.rotation1.GetRotation(this.label1).RotateZ = (int)e.Angle;
		}

		private void label1_Pinch(object sender, PinchEventArgs e)
		{
		}

		private void label1_Swipe(object sender, SwipeEventArgs e)
		{
		}

		private void label1_TouchStart(object sender, TouchEventArgs e)
		{
			this.drawing = true;
		}

		private void label1_Track(object sender, TrackEventArgs e)
		{
		}

		private void label1_Paint(object sender, PaintEventArgs e)
		{
			if (draw.Count > 1)
			{
				Point start = Point.Empty;
				Point end = Point.Empty;
				for (int i = 0; i < draw.Count; i++)
				{
					// start?
					if  (start.IsEmpty)
					{
						start = this.label1.PointToClient(draw[i]);
						continue;
					}

					// break?
					if (draw[i].IsEmpty)
					{
						start = Point.Empty;
						continue;
					}

					end = this.label1.PointToClient(draw[i]);
					e.Graphics.DrawLine(Pens.Red, start, end);
					start = end;
				}
			}
		}

		private void button1_Click(object sender, EventArgs e)
		{
			lock (draw)
			{
				draw.Clear();
				// Not needed in this case.
				// DrawChanged?.Invoke(draw, EventArgs.Empty);
			}
		}

		private void label1_TouchMove(object sender, TouchEventArgs e)
		{
			if (this.drawing)
			{
				lock (draw)
				{
					draw.AddRange(e.Locations);
					// Not needed in this case.
					// DrawChanged?.Invoke(draw, EventArgs.Empty);
				}
			}
		}

		private void label1_TouchEnd(object sender, TouchEventArgs e)
		{
			this.drawing = false;

			lock (draw)
			{
				draw.Add(Point.Empty);
				// Not needed in this case.
				// DrawChanged?.Invoke(draw, EventArgs.Empty);
			}
		}

		bool drawing = false;

		// Not needed in this case.
		// static EventHandler DrawChanged;

		static List<Point> draw = new List<Point>();

	}
}
